#include "StdAfx.h"
#include "MainWindow.h"

HINSTANCE g_hInstance = NULL;

extern "C" int __stdcall WinMain(HINSTANCE hInstance,
                                  HINSTANCE hPrevInstance,
                                  char * lpstrCmdLine,
                                  int nShowCmd) throw()
{
    ::g_hInstance = hInstance;
    
    if (Window::RegisterWindowClass(L"TestWindowClass",::LoadCursor(NULL,IDC_ARROW),
        ::LoadIcon(NULL,IDI_APPLICATION),::LoadIcon(NULL,IDI_APPLICATION)) == false)
    {
        ::MessageBoxW(HWND_DESKTOP,L"Failed to register window class!",L"",MB_OK);
        return -1;
    }
        
    Window * pWindow = new MainWindow();
    
    if (pWindow->Create(L"TestWindowClass",L"TestWindow",WS_OVERLAPPEDWINDOW,
        WS_EX_APPWINDOW,0,0,640,480,1000,NULL) == false)
    {
        const unsigned long dwLastError = ::GetLastError();
        wchar_t szError[256];
        ::MessageBoxW(HWND_DESKTOP,L"Failed to create window!",L"",MB_OK);
        return -1;
    }
        
    pWindow->Show(nShowCmd);
    pWindow->Update();
    
    MSG message;
    long nCheck = 0;
    
    do
    {
        nCheck = ::GetMessage(&message,0,0,0);
        
        if (nCheck == 0 || nCheck == -1)
        {
            break;
        }
        
        ::TranslateMessage(&message);
        ::DispatchMessage(&message);
        
    } while (true);
    
    Window::UnregisterWindowClass(L"TestWindowClass");
    
    return 0;
}
